Subject: scroll left/right with mouse wheel

Adds a units option for the scroll_left()/scroll_right() action routines:

 * "chars"
 * "tabs"
 * "emtabs"
 * "pixels"

---

 doc/help.etx  |   22 +++++++++++++---------
 source/text.c |   46 +++++++++++++++++++++++++++++++++++++++++++++-
 util/misc.c   |   47 ++++++++++++++++++++++++++++++++++++++++++++++-
 3 files changed, 104 insertions(+), 11 deletions(-)

diff --quilt old/source/text.c new/source/text.c
--- old/source/text.c
+++ new/source/text.c
@@ -428,6 +428,12 @@ static char defaultTranslations[] = 
     "<FocusIn>: focusIn()\n"
     "<FocusOut>: focusOut()\n"
     /* Support for mouse wheel in XFree86 */
+    "Shift Alt<Btn4Down>,<Btn4Up>: scroll_left(1)\n"
+    "Shift Alt<Btn5Down>,<Btn5Up>: scroll_right(1)\n"
+    "Ctrl Alt<Btn4Down>,<Btn4Up>: scroll_left(1, tab)\n"
+    "Ctrl Alt<Btn5Down>,<Btn5Up>: scroll_right(1, tab)\n"
+    "Alt<Btn4Down>,<Btn4Up>: scroll_left(1, char)\n"
+    "Alt<Btn5Down>,<Btn5Up>: scroll_right(1, char)\n"
     "Shift<Btn4Down>,<Btn4Up>: scroll_up(1)\n"
     "Shift<Btn5Down>,<Btn5Up>: scroll_down(1)\n"
     "Ctrl<Btn4Down>,<Btn4Up>: scroll_up(1, pages)\n"
@@ -3401,8 +3407,27 @@ static void scrollLeftAP(Widget w, XEven
     
     if (*nArgs == 0 || sscanf(args[0], "%d", &nPixels) != 1)
     	return;
+
+    if (*nArgs == 2) {
+        if (strncmp(args[1], "char", 4) == 0) {
+            nPixels *= TextDMinFontWidth(textD, True);
+        }
+        else if (strncmp(args[1], "tab", 3) == 0) {
+            nPixels *= TextDMinFontWidth(textD, True) * textD->buffer->tabDist;
+        }
+        else if (strncmp(args[1], "emtab", 5) == 0) {
+           int tabDist = ((TextWidget)w)->text.emulateTabs;
+            if (tabDist <= 0)
+                tabDist = textD->buffer->tabDist;
+            nPixels *= TextDMinFontWidth(textD, True) * tabDist;
+        }
+        else if (strncmp(args[1], "pixel", 5) != 0) {
+            return;
+        }
+    }
+
     XtVaGetValues(textD->hScrollBar, XmNmaximum, &sliderMax, 
-   	XmNsliderSize, &sliderSize, NULL);
+    	    XmNsliderSize, &sliderSize, NULL);
     horizOffset = min(max(0, textD->horizOffset - nPixels), sliderMax - sliderSize);
     if (textD->horizOffset != horizOffset) {
 	TextDSetScroll(textD, textD->topLineNum, horizOffset);
@@ -3418,6 +3443,25 @@ static void scrollRightAP(Widget w, XEve
     
     if (*nArgs == 0 || sscanf(args[0], "%d", &nPixels) != 1)
     	return;
+
+    if (*nArgs == 2) {
+        if (strncmp(args[1], "char", 4) == 0) {
+            nPixels *= TextDMinFontWidth(textD, True);
+        }
+        else if (strncmp(args[1], "tab", 3) == 0) {
+            nPixels *= TextDMinFontWidth(textD, True) * textD->buffer->tabDist;
+        }
+        else if (strncmp(args[1], "emtab", 5) == 0) {
+            int tabDist = ((TextWidget)w)->text.emulateTabs;
+            if (tabDist <= 0)
+                tabDist = textD->buffer->tabDist;
+            nPixels *= TextDMinFontWidth(textD, True) * tabDist;
+        }
+        else if (strncmp(args[1], "pixel", 5) != 0) {
+            return;
+        }
+    }
+
     XtVaGetValues(textD->hScrollBar, XmNmaximum, &sliderMax, 
     	    XmNsliderSize, &sliderSize, NULL);
     horizOffset = min(max(0, textD->horizOffset + nPixels), sliderMax - sliderSize);
diff --quilt old/util/misc.c new/util/misc.c
--- old/util/misc.c
+++ new/util/misc.c
@@ -156,6 +156,10 @@ static void pageDownAP(Widget w, XEvent 
 	Cardinal *nArgs);
 static void pageUpAP(Widget w, XEvent *event, String *args, 
 	Cardinal *nArgs);
+static void scrollLeftAP(Widget w, XEvent *event, String *args,
+	Cardinal *nArgs);
+static void scrollRightAP(Widget w, XEvent *event, String *args,
+	Cardinal *nArgs);
 static long queryDesktop(Display *display, Window window, Atom deskTopAtom);
 static void warning(const char* mesg);
 static void microsleep(long usecs);
@@ -1929,7 +1933,9 @@ void InstallMouseWheelActions(XtAppConte
       	{"scrolled-window-scroll-up",   scrollUpAP},
       	{"scrolled-window-page-up",     pageUpAP},
       	{"scrolled-window-scroll-down", scrollDownAP},
-      	{"scrolled-window-page-down",   pageDownAP} 
+      	{"scrolled-window-page-down",   pageDownAP},
+      	{"scrolled-window-scroll-left",  scrollLeftAP},
+      	{"scrolled-window-scroll-right", scrollRightAP}
     };
 
     XtAppAddActions(context, Actions, XtNumber(Actions));
@@ -1944,6 +1950,12 @@ void AddMouseWheelSupport(Widget w)
     if (XmIsScrolledWindow(XtParent(w))) 
     {
         static const char scrollTranslations[] =
+           "Shift Alt<Btn4Down>,<Btn4Up>: scrolled-window-scroll-left(1)\n"
+           "Shift Alt<Btn5Down>,<Btn5Up>: scrolled-window-scroll-right(1)\n"
+           "Ctrl Alt<Btn4Down>,<Btn4Up>:  scrolled-window-scroll-left(8)\n"
+           "Ctrl Alt<Btn5Down>,<Btn5Up>:  scrolled-window-scroll-right(8)\n"
+           "Alt<Btn4Down>,<Btn4Up>:       scrolled-window-scroll-left(4)\n"
+           "Alt<Btn5Down>,<Btn5Up>:       scrolled-window-scroll-right(4)\n"
            "Shift<Btn4Down>,<Btn4Up>: scrolled-window-scroll-up(1)\n"
            "Shift<Btn5Down>,<Btn5Up>: scrolled-window-scroll-down(1)\n"
            "Ctrl<Btn4Down>,<Btn4Up>:  scrolled-window-page-up()\n"
@@ -2020,6 +2032,39 @@ static void scrollDownAP(Widget w, XEven
     return;
 }
 
+static void scrollLeftAP(Widget w, XEvent *event, String *args, Cardinal *nArgs)
+{
+    Widget scrolledWindow, scrollBar;
+    String al[1];
+    int i, nLines;
+
+    if (*nArgs == 0 || sscanf(args[0], "%d", &nLines) != 1)
+       return;
+    al[0] = "Left";
+    scrolledWindow = XtParent(w);
+    scrollBar = XtNameToWidget (scrolledWindow, "HorScrollBar");
+    if (scrollBar)
+        for (i=0; i<nLines; i++)
+            XtCallActionProc(scrollBar, "IncrementUpOrLeft", event, al, 1) ;
+    return;
+}
+
+static void scrollRightAP(Widget w, XEvent *event, String *args, Cardinal *nArgs)
+{
+    Widget scrolledWindow, scrollBar;
+    String al[1];
+    int i, nLines;
+
+    if (*nArgs == 0 || sscanf(args[0], "%d", &nLines) != 1)
+       return;
+    al[0] = "Right";
+    scrolledWindow = XtParent(w);
+    scrollBar = XtNameToWidget (scrolledWindow, "HorScrollBar");
+    if (scrollBar)
+        for (i=0; i<nLines; i++)
+            XtCallActionProc(scrollBar, "IncrementDownOrRight", event, al, 1) ;
+    return;
+}
 
 /* 
 ** This is a disguisting hack to work around a bug in OpenMotif.
diff --quilt old/doc/help.etx new/doc/help.etx
--- old/doc/help.etx
+++ new/doc/help.etx
@@ -2503,7 +2503,7 @@ Macro Subroutines
   Width of the current pane in pixels.
 
 **$em_tab_dist**
-  If tab emulation is turned on in the Tabs...
+  If tab emulation is turned on in the Tab Stops...
   dialog of the Preferences menu, the value is the
   distance between emulated tab stops. If tab
   emulation is turned off, the value is 0.
@@ -2622,7 +2622,7 @@ Macro Subroutines
 **$tab_dist**
   The distance between tab stops for a
   hardware tab character, as set in the
-  Tabs... dialog of the Preferences menu.
+  Tab Stops... dialog of the Preferences menu.
 
 **$text_length**
   The length of the text in the current document.
@@ -2633,8 +2633,8 @@ Macro Subroutines
 **$use_tabs**
   Whether the user is allowing the NEdit to insert tab characters to maintain
   spacing in tab emulation and rectangular dragging operations. (The setting of
-  the "Use tab characters in padding and emulated tabs" button in the Tabs...
-  dialog of the Preferences menu.)
+  the "Use tab characters in padding and emulated tabs" button in the
+  Tab Stops... dialog of the Preferences menu.)
 
 **$wrap_margin**
   The right margin in the current window for text wrapping and filling.
@@ -3783,11 +3783,15 @@ Action Routines
   Scroll the display down (towards the end of the file) by a given
   number of units, units being lines or pages. Default units are lines.
 
-**scroll_left( nPixels )**
-  Scroll the display left by nPixels.
-
-**scroll_right( nPixels )**
-  Scroll the display right by nPixels.
+**scroll_left( nUnits, ["chars" | "tabs" | "emtabs" | "pixels"] )**
+  Scroll the display left by a given number of units, units being characters,
+  hardware tab stop spacing, emulated tab stop spacing, or pixels. If emulated
+  tabs are disabled in the Tab Stops... dialog, "emtabs" is the same as "tabs".
+
+**scroll_right( nUnits, ["chars" | "tabs" | "emtabs" | "pixels"] )**
+  Scroll the display right by a given number of units, units being characters,
+  hardware tab stop spacing, emulated tab stop spacing, or pixels. If emulated
+  tabs are disabled in the Tab Stops... dialog, "emtabs" is the same as "tabs".
 
 **scroll_up( nUnits, ["lines" | "pages"] )**
   Scroll the display up (towards the beginning of the file) by a given
